=== debian/changelog ===
cataclysm-dda (0.E-2) unstable; urgency=medium

  * Delay building of tests to dh_auto_test and skip test runs on mipsel.
    The mipsel buildd was running out of memory while linking the tests.
  * Move more build dependencies to Build-Depends-Arch.
  * Don't run tests if nocheck build option is set.
  * Improve cross buildability:
    - Don't run json linter during build
    - Use PKG_CONFIG variable consistently in Makefile

 -- Reiner Herrmann <reiner@reiner-h.de>  Sat, 04 Apr 2020 17:41:50 +0200

cataclysm-dda (0.E-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches and drop obsolete ones.
  * Drop dependencies and other references to Lua, as upstream dropped
    support.
  * Update watch file URL to get latest release without pre-releases.
  * Bump Standards-Version to 4.5.0.
  * Build-depend on gettext.
  * Update copyrights.

 -- Reiner Herrmann <reiner@reiner-h.de>  Wed, 01 Apr 2020 23:10:39 +0200
